/*
 * Copyright 1991, 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*
 *
 * curve.h
 *
 * Part of the "Curve Demo"
 * by Howard Look for Silicon Graphics
 *
 * June, 1989
 *
 * This file contains all of the defines used in the curve demo.
 *
 */

/* Basis types */
#define BEZIER		1
#define CARDINAL	2
#define BSPLINE		3

/* Display modes */
#define TWO_D	1
#define THREE_D	2

/* Precision menu. Make sure these are integer multiples. */
#define MIN_PRECISION	5
#define MAX_PRECISION	30
#define PRECISION_STEP	5

/* Speed menu. These must also be integer multiples. */
#define MIN_SPEED		10
#define MAX_SPEED		100
#define SPEED_STEP		10
#define DEFAULT_SPEED	10

/* Linestyles */
#define SOLID	0
#define DOTTED	1
#define DASHED	2

/* Patterns for the linestyles... */
/* 2 pixels on, 2 pixels off */
#define DOTTED_PATTERN 0xCCCC
/* 8 pixels on, 8 pixels off */
#define DASHED_PATTERN 0xFF00

#define ON	1
#define OFF	0

#define PI 3.141592653589

/* turns radians into degrees */
#define RAD *180.0/PI
/* and vice versa */
#define DEG *PI/180.0

/* Maximum control points markers. It gets a little ugly, but... */
#define MAX_MARKERS 999

/* Whizbangs !
 * New whizbangs must be defined here, built in whiz.c, added to menus
 * in menus.c, and changed in control.c
 */
#define COIL		1
#define BEDSPRING	2
#define DOUGHNUT	3

/* Hardware types */
#define ECLIPSE8	1
#define ECLIPSE24	2
#define GT			3


