/*
 * Copyright 1991, 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#include "gl.h"
#include "fmclient.h"

/* current version of the states.bin data file */
#define CURVERSION 120290
/* magic number for demograph data file */
#define MAGIC	    19971989

#define MAXTITLE    24
#define MAXSTRING   256
#define MAXDATA	    (XMAXSCREEN / 2)
#define NUMSTATES   48

#define LINES		0
#define TOPS		1
#define SOLID		2
#define LIGHTED		3

#define NOPORT	    0
#define SLIDERPORT  1
#define MAPPORT	    2

#define UP	0
#define DOWN	1

#define SPIN	0
#define TRANSXY 1
#define TRANSZ	2

#define WID 302
#define SLIDERHT 33
#define STATUSHT 23
#define HT (WID + SLIDERHT + STATUSHT - 2)
#define S_FRAME_WID 7
#define M_FRAME_WID 9
#define S_WID_2_HT 1.5
#define DATECHARS 8
#define SLIDERWID (DATECHARS * 6 + S_FRAME_WID + 6)

/* arbitrary minimum */
#define MINZSCALE	0.00000001

typedef struct {
    char date[12];
    float data[NUMSTATES];
} DATA;   

typedef struct categoryrec {
    char title[MAXTITLE];
    DATA dataarray[MAXDATA];
    float scale;
    struct  categoryrec *next;
} CATEGORY;

typedef struct {
    int zbuffer;
    int RGB;
} MACHREC;

typedef struct {
    long orgx, orgy;
    int sliderminx, sliderminy, slidermaxx, slidermaxy;
    int sliderwid;
    int fps;	/* TRUE if frames per second is to be displayed */
    int mapminx, mapminy, mapmaxx, mapmaxy;
    int statminx, statminy, statmaxx, statmaxy;
    float slideroldx, scale;
    float lasttime;
} WINREC;


typedef struct {
    float yscale;
    float xscale;
    float xoffset;
    float yoffset;
    int lwid;
} FONTREC;


typedef struct {
    float ry;
    float rx;
    float tx;
    float ty;
    float tz;
} MAPMOVE;
